@mixin transition($transition...) {
  @if $enable-transitions {
    @if length($transition) == 0 {
      transition: $transition-base;
    } @else {
      transition: $transition;
    }
  }

  @if $enable-prefers-reduced-motion-media-query {
    @media (prefers-reduced-motion: reduce) {
      transition: none;
    }
  }
}

@mixin animation(
  $animation-name,
  $animation-duration: (duration delay),
  $animation-prop: ()) {
  @keyframes #{$animation-name} {
    @content;
  }

  $duration: map-get($animation-duration, duration);
  $delay: map-get($animation-duration, delay);

  @if $duration == 'slow' {
    $duration: 1s;
  } @else if $duration == 'normal' {
    $duration: .5s;
  } @else if $duration == 'fast' {
    $duration: .3s;
  } @else {
    $duration: $duration;
  }

  .#{$animation-name} {
    animation-name: #{$animation-name} !important;
    animation-duration: $duration !important;
    animation-delay: if($delay, $delay, 0s) !important;
    @each $prop, $value in $animation-prop {
      #{$prop}: $value;
    }
  }
}

@mixin set-animation($animation-name, $duration: null) {
  @if $enable-animations {
    $sub-name: str-slice($animation-name, 0, 1);
    @if $sub-name == '.' {
      @extend #{$animation-name};
    } @else {
      animation-name: #{$animation-name};
      animation-duration: if($duration, $duration, .5s);
    }
  }
}